#include <stdio.h>
#include <stdlib.h>

typedef struct LIST
{
	int Hodnota;
	struct LIST * Levy;
	struct LIST * Pravy;
} List; // List je jina promenna nez LIST, platí ze List = struct LIST

void PridejDoStromu(List**Strom, int X) //promenna typu List** (ukazatel na ukazatel na List) a jmenuje se Strom
{
	List* Listek=*Strom;
	if (!*Strom)
	{
		*Strom=(List*)malloc(sizeof(List)); //vytvori novy (prvni) List
		(*Strom)->Hodnota=X; //-> znamena, že prejdeme na atribut struktury, který se jmenuje Hodnota, před sipkou musíme mít ukazatel (*Strom), ekvivalent je (**Strom).Hodnota
		(*Strom)->Levy=NULL;
		(*Strom)->Pravy=NULL;
		return;
	}
	while (1)
	{
		if ((Listek->Hodnota>X)&&(Listek->Levy)) Listek=Listek->Levy;
		else if ((Listek->Hodnota<X)&&(Listek->Pravy)) Listek=Listek->Pravy;
		else break;
	}
	if (Listek->Hodnota<X) 
	{
		Listek->Pravy=(List*)malloc(sizeof(List));
		Listek->Pravy->Hodnota=X;
		Listek->Pravy->Pravy=NULL;
		Listek->Pravy->Levy=NULL;
	}
	if (Listek->Hodnota>X) 
	{
		Listek->Levy=(List*)malloc(sizeof(List));
		Listek->Levy->Hodnota=X;
		Listek->Levy->Pravy=NULL;
		Listek->Levy->Levy=NULL;
	}
}


int NactiHodnotu(int *Cislo)
{	
	printf("Zadej cislo: ");
	return scanf("%d",Cislo)==1; //vlozi se do adresy v promenne Cislo (ukazatel), jestli je pocet uspesnych operaci rovno 1, pak vráti true, jinak false
}

void VypisStrom(List*Strom)
{
	if (!Strom) return;
	VypisStrom(Strom->Levy);
	printf("%d\n",Strom->Hodnota);
	VypisStrom(Strom->Pravy);
}

void UvolniStrom(List*Strom)
{
	if (!Strom) return;
	UvolniStrom(Strom->Levy);
	UvolniStrom(Strom->Pravy);
	free (Strom);
}

int HledejCislo(List*Strom,int X)
{
	if (!Strom) return 0;
	if (Strom->Hodnota==X) return 1;
	return ((Strom->Hodnota<X)&&(HledejCislo(Strom->Pravy,X)))||((Strom->Hodnota>X)&&(HledejCislo(Strom->Levy,X)));
}

int main (void)
{
	int C;
	List *Stromek=NULL;
	while (NactiHodnotu(&C)) PridejDoStromu(&Stromek,C);
	getchar(); //funkce, ktera nacte jeden znak ze vstupu, zde nacte neciselny znak, kterym jsme ukoncili zadavani (nelze ukoncit zadavani Ctrl+Z!)
	printf("Vypis zadanych cisel\n");
	VypisStrom(Stromek);
	while (1)
	{
		printf("Zadej hledane cislo: ");
		if (scanf("%d",&C)==1) break;
		printf("Nespravny vstup!\n");
	}
	if (HledejCislo(Stromek,C)) printf("Strom obsahuje hledane cislo\n"); else printf("Strom neobsahuje hledane cislo\n");
	UvolniStrom(Stromek);
	return 0;
}
